diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-rcache.cc ns-3.38/src/dsr/model/dsr-rcache.cc
--- ns-3.37/src/dsr/model/dsr-rcache.cc	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/dsr/model/dsr-rcache.cc	2023-03-16 20:54:23.604868400 -0700
@@ -374,7 +374,7 @@
             if (s.find(ip) == s.end())
             {
                 /*
-                 * \brief The followings are for comparison
+                 * \brief The following are for comparison
                  */
                 if (j->second <= temp)
                 {
@@ -821,7 +821,7 @@
         // Purge the link node cache first
         PurgeLinkNode();
         /*
-         * The followings are for cleaning the broken link in link cache
+         * The following are for cleaning the broken link in link cache
          * We basically remove the link between errorSrc and unreachNode
          */
         Link link1(errorSrc, unreachNode);
@@ -837,7 +837,7 @@
         std::map<Ipv4Address, DsrNodeStab>::iterator i = m_nodeCache.find(errorSrc);
         if (i == m_nodeCache.end())
         {
-            NS_LOG_LOGIC("Update the node stability unsuccessfully");
+            NS_LOG_LOGIC("Update the node stability unsuccessfuly");
         }
         else
         {
@@ -846,7 +846,7 @@
         i = m_nodeCache.find(unreachNode);
         if (i == m_nodeCache.end())
         {
-            NS_LOG_LOGIC("Update the node stability unsuccessfully");
+            NS_LOG_LOGIC("Update the node stability unsuccessfuly");
         }
         else
         {
@@ -858,7 +858,7 @@
     else
     {
         /*
-         * the followings are for cleaning the broken link in pathcache
+         * the following are for cleaning the broken link in pathcache
          *
          */
         Purge();
@@ -960,7 +960,7 @@
             {
                 m_sortedRoutes.erase(jtmp);
             }
-            if (rtVector.size())
+            if (!rtVector.empty())
             {
                 /*
                  * Save the new route cache along with the destination address in map
@@ -983,7 +983,7 @@
     /*
      * Check elements in a route vector, used when one wants to check the IP addresses saved in
      */
-    if (!vec.size())
+    if (vec.empty())
     {
         NS_LOG_DEBUG("The vector is empty");
     }
@@ -1030,7 +1030,7 @@
         Ipv4Address dst = i->first;
         std::list<DsrRouteCacheEntry> rtVector = i->second;
         NS_LOG_DEBUG("The route vector size of 1 " << dst << " " << rtVector.size());
-        if (rtVector.size())
+        if (!rtVector.empty())
         {
             for (std::list<DsrRouteCacheEntry>::iterator j = rtVector.begin(); j != rtVector.end();)
             {
@@ -1054,7 +1054,7 @@
                 }
             }
             NS_LOG_DEBUG("The route vector size of 2 " << dst << " " << rtVector.size());
-            if (rtVector.size())
+            if (!rtVector.empty())
             {
                 ++i;
                 m_sortedRoutes.erase(itmp); // erase the entry first
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-routing.cc ns-3.38/src/dsr/model/dsr-routing.cc
--- ns-3.37/src/dsr/model/dsr-routing.cc	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/dsr/model/dsr-routing.cc	2023-03-16 20:54:23.604868400 -0700
@@ -551,7 +551,7 @@
     std::vector<std::string> elements;
     size_t pos1 = 0;
     size_t pos2;
-    while (pos1 != context.npos)
+    while (pos1 != std::string::npos)
     {
         pos1 = context.find('/', pos1);
         pos2 = context.find('/', pos1 + 1);
@@ -743,7 +743,7 @@
     /*
      * Check elements in a route vector
      */
-    if (!vec.size())
+    if (vec.empty())
     {
         NS_LOG_DEBUG("The vector is empty");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-rreq-table.h ns-3.38/src/dsr/model/dsr-rreq-table.h
--- ns-3.37/src/dsr/model/dsr-rreq-table.h	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/dsr/model/dsr-rreq-table.h	2023-03-16 20:54:23.604868400 -0700
@@ -199,7 +199,7 @@
 
     // \}
   private:
-    Ipv4Address m_destination; //!< IPv4 address of the destinaton
+    Ipv4Address m_destination; //!< IPv4 address of the destination
     Ipv4Address m_source;      //!< IPv4 address of the source
     uint16_t m_identification; //!< Route request identification
     Time m_expire;             //!< Route request expire time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/energy/examples/CMakeLists.txt ns-3.38/src/energy/examples/CMakeLists.txt
--- ns-3.37/src/energy/examples/CMakeLists.txt	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/energy/examples/CMakeLists.txt	2023-03-16 20:54:23.604868400 -0700
@@ -1,6 +1,6 @@
 build_lib_example(
-  NAME li-ion-energy-source
-  SOURCE_FILES li-ion-energy-source.cc
+  NAME li-ion-energy-source-example
+  SOURCE_FILES li-ion-energy-source-example.cc
   LIBRARIES_TO_LINK ${libcore}
                     ${libenergy}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/energy/examples/li-ion-energy-source-example.cc ns-3.38/src/energy/examples/li-ion-energy-source-example.cc
--- ns-3.37/src/energy/examples/li-ion-energy-source-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/energy/examples/li-ion-energy-source-example.cc	2023-03-16 20:54:23.604868400 -0700
@@ -0,0 +1,104 @@
+/*
+ * Copyright (c) 2010 Andrea Sacco
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Andrea Sacco <andrea.sacco85@gmail.com>
+ */
+
+#include "ns3/command-line.h"
+#include "ns3/energy-source-container.h"
+#include "ns3/li-ion-energy-source.h"
+#include "ns3/log.h"
+#include "ns3/simple-device-energy-model.h"
+#include "ns3/simulator.h"
+
+using namespace ns3;
+
+/**
+ * In this simple example, we show how to create and drain energy from a
+ * LiIonEnergySource.
+ * We make a series of discharge calls to the energy source class with
+ * different current drain and duration until all the energy is depleted
+ * from the cell.
+ *
+ * Every 20 seconds it is printed out the actual cell voltage to verify
+ * that it follows the discharge curve of the datasheet [1].
+ *
+ * At the end of the example it is verified that after the energy depletion
+ * call, the cell voltage is below the threshold voltage.
+ *
+ * References:
+ * [1] Panasonic CGR18650DA Datasheet,
+ * http://www.panasonic.com/industrial/includes/pdf/Panasonic_LiIon_CGR18650DA.pdf
+ */
+
+static void
+PrintCellInfo(Ptr<LiIonEnergySource> es)
+{
+    std::cout << "At " << Simulator::Now().As(Time::S)
+              << " Cell voltage: " << es->GetSupplyVoltage()
+              << " V Remaining Capacity: " << es->GetRemainingEnergy() / (3.6 * 3600) << " Ah"
+              << std::endl;
+
+    if (!Simulator::IsFinished())
+    {
+        Simulator::Schedule(Seconds(20), &PrintCellInfo, es);
+    }
+}
+
+int
+main(int argc, char** argv)
+{
+    CommandLine cmd(__FILE__);
+    cmd.Parse(argc, argv);
+
+    // uncomment below to see the energy consumption details
+    // LogComponentEnable ("LiIonEnergySource", LOG_LEVEL_DEBUG);
+
+    Ptr<Node> node = CreateObject<Node>();
+
+    Ptr<SimpleDeviceEnergyModel> sem = CreateObject<SimpleDeviceEnergyModel>();
+    Ptr<EnergySourceContainer> esCont = CreateObject<EnergySourceContainer>();
+    Ptr<LiIonEnergySource> es = CreateObject<LiIonEnergySource>();
+    esCont->Add(es);
+    es->SetNode(node);
+    sem->SetEnergySource(es);
+    es->AppendDeviceEnergyModel(sem);
+    sem->SetNode(node);
+    node->AggregateObject(esCont);
+
+    Time now = Simulator::Now();
+
+    // discharge at 2.33 A for 1700 seconds
+    sem->SetCurrentA(2.33);
+    now += Seconds(1701);
+
+    // discharge at 4.66 A for 628 seconds
+    Simulator::Schedule(now, &SimpleDeviceEnergyModel::SetCurrentA, sem, 4.66);
+    now += Seconds(600);
+
+    PrintCellInfo(es);
+
+    Simulator::Stop(now);
+    Simulator::Run();
+    Simulator::Destroy();
+
+    // the cell voltage should be under 3.3v
+    DoubleValue v;
+    es->GetAttribute("ThresholdVoltage", v);
+    NS_ASSERT(es->GetSupplyVoltage() <= v.Get());
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/energy/examples/rv-battery-model-test.cc ns-3.38/src/energy/examples/rv-battery-model-test.cc
--- ns-3.37/src/energy/examples/rv-battery-model-test.cc	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/energy/examples/rv-battery-model-test.cc	2023-03-16 20:54:23.604868400 -0700
@@ -73,7 +73,7 @@
      * Runs simulation with constant load and checks the battery lifetime with
      * known results.
      */
-    bool ConstantLoadTest(double load, Time expLifetime);
+    bool ConstantLoadTest(double load, Time expLifetime) const;
 
     /**
      * \param loads Load profile.
@@ -86,16 +86,16 @@
      */
     bool VariableLoadTest(std::vector<double> loads,
                           std::vector<Time> timeStamps,
-                          Time expLifetime);
+                          Time expLifetime) const;
 
     /// Load profile of the battery
-    typedef struct LoadProfile
+    struct LoadProfile
     {
         std::vector<double> loads;    //!< Loads container
         std::vector<Time> timeStamps; //!< Timestamps container
         Time itsyLifetime;            //!< Expected lifetime for an ITSY battery
         Time dualFoilLifeTime;        //!< Expected lifetime for a Dualfoil battery
-    } LoadProfile;
+    };
 
     std::vector<LoadProfile> m_loadProfiles; //!< Load profiles
     double m_alpha;                          //!< Alpha parameter of the battery model
@@ -715,7 +715,7 @@
 }
 
 bool
-BatteryLifetimeTest::ConstantLoadTest(double load, Time expLifetime)
+BatteryLifetimeTest::ConstantLoadTest(double load, Time expLifetime) const
 {
     // create single node
     NodeContainer c;
@@ -800,7 +800,7 @@
 bool
 BatteryLifetimeTest::VariableLoadTest(std::vector<double> loads,
                                       std::vector<Time> timeStamps,
-                                      Time expLifetime)
+                                      Time expLifetime) const
 {
     NS_ASSERT(loads.size() == timeStamps.size());
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/dummy-network.cc ns-3.38/src/fd-net-device/examples/dummy-network.cc
--- ns-3.37/src/fd-net-device/examples/dummy-network.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/dummy-network.cc	2023-03-16 20:54:23.604868400 -0700
@@ -64,9 +64,9 @@
     addresses.SetBase("10.0.0.0", "255.255.255.0");
     Ipv4InterfaceContainer interfaces = addresses.Assign(devices);
 
-    Ptr<V4Ping> app = CreateObject<V4Ping>();
-    app->SetAttribute("Remote", Ipv4AddressValue(interfaces.GetAddress(0)));
-    app->SetAttribute("Verbose", BooleanValue(true));
+    Ptr<Ping> app = CreateObject<Ping>();
+    app->SetAttribute("Destination", AddressValue(interfaces.GetAddress(0)));
+    app->SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
     nodes.Get(1)->AddApplication(app);
     app->SetStartTime(Seconds(0.0));
     app->SetStopTime(Seconds(4.0));
@@ -85,4 +85,6 @@
     Simulator::Stop(Seconds(5) + TimeStep(1));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd2fd-onoff.cc ns-3.38/src/fd-net-device/examples/fd2fd-onoff.cc
--- ns-3.37/src/fd-net-device/examples/fd2fd-onoff.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd2fd-onoff.cc	2023-03-16 20:54:23.608868600 -0700
@@ -140,4 +140,6 @@
     Simulator::Stop(Seconds(30.0));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-emu-onoff.cc ns-3.38/src/fd-net-device/examples/fd-emu-onoff.cc
--- ns-3.37/src/fd-net-device/examples/fd-emu-onoff.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-emu-onoff.cc	2023-03-16 20:54:23.604868400 -0700
@@ -218,7 +218,7 @@
     if (emuMode == "dpdk")
     {
         DpdkNetDeviceHelper* dpdk = new DpdkNetDeviceHelper();
-        // Use e1000 driver library (this is for IGb PMD supproting Intel 1GbE NIC)
+        // Use e1000 driver library (this is for IGb PMD supporting Intel 1GbE NIC)
         // NOTE: DPDK supports multiple Poll Mode Drivers (PMDs) and you can use it
         // based on your NIC. You just need to set pmd library as follows:
         dpdk->SetPmdLibrary("librte_pmd_e1000.so");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-emu-ping.cc ns-3.38/src/fd-net-device/examples/fd-emu-ping.cc
--- ns-3.37/src/fd-net-device/examples/fd-emu-ping.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-emu-ping.cc	2023-03-16 20:54:23.604868400 -0700
@@ -94,9 +94,9 @@
 NS_LOG_COMPONENT_DEFINE("PingEmulationExample");
 
 static void
-PingRtt(std::string context, Time rtt)
+PingRtt(std::string context, uint16_t seqNo, Time rtt)
 {
-    NS_LOG_UNCOND("Received Response with RTT = " << rtt);
+    NS_LOG_UNCOND("Received " << seqNo << " Response with RTT = " << rtt);
 }
 
 int
@@ -201,7 +201,7 @@
     if (emuMode == "dpdk")
     {
         DpdkNetDeviceHelper* dpdk = new DpdkNetDeviceHelper();
-        // Use e1000 driver library (this is for IGb PMD supproting Intel 1GbE NIC)
+        // Use e1000 driver library (this is for IGb PMD supporting Intel 1GbE NIC)
         // NOTE: DPDK supports multiple Poll Mode Drivers (PMDs) and you can use it
         // based on your NIC. You just need to set pmd library as follows:
         dpdk->SetPmdLibrary("librte_pmd_e1000.so");
@@ -269,10 +269,10 @@
     // of a hassle and since there is no law that says we cannot mix the
     // helper API with the low level API, let's just use the helper.
     //
-    NS_LOG_INFO("Create V4Ping Appliation");
-    Ptr<V4Ping> app = CreateObject<V4Ping>();
-    app->SetAttribute("Remote", Ipv4AddressValue(remoteIp));
-    app->SetAttribute("Verbose", BooleanValue(true));
+    NS_LOG_INFO("Create Ping Application");
+    Ptr<Ping> app = CreateObject<Ping>();
+    app->SetAttribute("Destination", AddressValue(remoteIp));
+    app->SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
     node->AddApplication(app);
     app->SetStartTime(Seconds(1.0));
     app->SetStopTime(Seconds(22.0));
@@ -302,4 +302,6 @@
     Simulator::Destroy();
     delete helper;
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-emu-send.cc ns-3.38/src/fd-net-device/examples/fd-emu-send.cc
--- ns-3.37/src/fd-net-device/examples/fd-emu-send.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-emu-send.cc	2023-03-16 20:54:23.604868400 -0700
@@ -197,4 +197,6 @@
     Simulator::Destroy();
     delete helper;
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-emu-tc.cc ns-3.38/src/fd-net-device/examples/fd-emu-tc.cc
--- ns-3.37/src/fd-net-device/examples/fd-emu-tc.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-emu-tc.cc	2023-03-16 20:54:23.604868400 -0700
@@ -304,10 +304,9 @@
         }
 #endif
 
-        Ipv4GlobalRoutingHelper g;
         Ptr<OutputStreamWrapper> routingStream =
             Create<OutputStreamWrapper>("router-routes.txt", std::ios::out);
-        g.PrintRoutingTableAllAt(Seconds(3), routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(3), routingStream);
     }
 
     NS_LOG_INFO("Run Emulation.");
@@ -317,4 +316,6 @@
     delete helper0;
     delete helper1;
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-emu-udp-echo.cc ns-3.38/src/fd-net-device/examples/fd-emu-udp-echo.cc
--- ns-3.37/src/fd-net-device/examples/fd-emu-udp-echo.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-emu-udp-echo.cc	2023-03-16 20:54:23.608868600 -0700
@@ -40,7 +40,7 @@
 // (OUI) 00:00:00 as a base.  This vendor code is not assigned to any
 // organization and so should not conflict with any real hardware.  We'll use
 // the first n of these addresses, where n is the number of nodes, in this
-// simualtion.  It is up to you to determine that using these MAC addresses is
+// simulation.  It is up to you to determine that using these MAC addresses is
 // okay on your network and won't conflict with anything else (including another
 // simulation using emu devices) on your network.  Once you have made this
 // determination, you need to put the interface you chose into promiscuous mode.
@@ -236,4 +236,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-tap-ping6.cc ns-3.38/src/fd-net-device/examples/fd-tap-ping6.cc
--- ns-3.37/src/fd-net-device/examples/fd-tap-ping6.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-tap-ping6.cc	2023-03-16 20:54:23.608868600 -0700
@@ -102,12 +102,12 @@
     //
     Ipv6AddressHelper ipv6;
 
-    ipv6.SetBase(Ipv6Address("2001:0DB8:1::"), Ipv6Prefix(64));
+    ipv6.SetBase(Ipv6Address("4001:beef:1::"), Ipv6Prefix(64));
     Ipv6InterfaceContainer i1 = ipv6.Assign(devs);
     i1.SetForwarding(1, true);
     i1.SetDefaultRouteInAllNodes(1);
 
-    ipv6.SetBase(Ipv6Address("2001:0DB8:2::"), Ipv6Prefix(64));
+    ipv6.SetBase(Ipv6Address("4001:beef:2::"), Ipv6Prefix(64));
     Ipv6Address tapAddr = ipv6.NewAddress();
     std::stringstream ss;
     std::string tapIp;
@@ -137,14 +137,20 @@
     uint32_t maxPacketCount = 1;
     Time interPacketInterval = Seconds(1.0);
 
-    Ping6Helper ping6;
-
-    ping6.SetRemote(tapIp.c_str());
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(n);
+    PingHelper ping(Ipv6Address(tapIp.c_str()));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(n);
+
+    // Ping6Helper ping6;
+
+    // ping6.SetRemote(tapIp.c_str());
+
+    // ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
+    // ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
+    // ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
+    // ApplicationContainer apps = ping6.Install(n);
     apps.Start(Seconds(2.0));
     apps.Stop(Seconds(20.0));
 
@@ -165,4 +171,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/fd-tap-ping.cc ns-3.38/src/fd-net-device/examples/fd-tap-ping.cc
--- ns-3.37/src/fd-net-device/examples/fd-tap-ping.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/fd-tap-ping.cc	2023-03-16 20:54:23.608868600 -0700
@@ -83,9 +83,9 @@
 NS_LOG_COMPONENT_DEFINE("TAPPingExample");
 
 static void
-PingRtt(std::string context, Time rtt)
+PingRtt(std::string context, uint16_t seqNo, Time rtt)
 {
-    NS_LOG_UNCOND("Received Response with RTT = " << rtt);
+    NS_LOG_UNCOND("Received " << seqNo << " Response with RTT = " << rtt);
 }
 
 int
@@ -201,10 +201,10 @@
     // of a hassle and since there is no law that says we cannot mix the
     // helper API with the low level API, let's just use the helper.
     //
-    NS_LOG_INFO("Create V4Ping Appliation");
-    Ptr<V4Ping> app = CreateObject<V4Ping>();
-    app->SetAttribute("Remote", Ipv4AddressValue(remoteIp));
-    app->SetAttribute("Verbose", BooleanValue(true));
+    NS_LOG_INFO("Create Ping Application");
+    Ptr<Ping> app = CreateObject<Ping>();
+    app->SetAttribute("Destination", AddressValue(remoteIp));
+    app->SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
     node->AddApplication(app);
     app->SetStartTime(Seconds(1.0));
     app->SetStopTime(Seconds(21.0));
@@ -233,4 +233,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/realtime-dummy-network.cc ns-3.38/src/fd-net-device/examples/realtime-dummy-network.cc
--- ns-3.37/src/fd-net-device/examples/realtime-dummy-network.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/realtime-dummy-network.cc	2023-03-16 20:54:23.608868600 -0700
@@ -67,9 +67,9 @@
     addresses.SetBase("10.0.0.0", "255.255.255.0");
     Ipv4InterfaceContainer interfaces = addresses.Assign(devices);
 
-    Ptr<V4Ping> app = CreateObject<V4Ping>();
-    app->SetAttribute("Remote", Ipv4AddressValue(interfaces.GetAddress(0)));
-    app->SetAttribute("Verbose", BooleanValue(true));
+    Ptr<Ping> app = CreateObject<Ping>();
+    app->SetAttribute("Destination", AddressValue(interfaces.GetAddress(0)));
+    app->SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
     nodes.Get(1)->AddApplication(app);
     app->SetStartTime(Seconds(0.0));
     app->SetStopTime(Seconds(4.0));
@@ -79,4 +79,6 @@
     Simulator::Stop(Seconds(5.));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/examples/realtime-fd2fd-onoff.cc ns-3.38/src/fd-net-device/examples/realtime-fd2fd-onoff.cc
--- ns-3.37/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2023-03-16 20:54:23.608868600 -0700
@@ -28,7 +28,7 @@
 //  |  fd-net-device |--------------|  fd-net-device |
 //  +----------------+              +----------------+
 //
-// This example is aimed at meassuring the thoughput of the FdNetDevice
+// This example is aimed at measuring the thoughput of the FdNetDevice
 // in a pure simulation. For this purpose two FdNetDevices, attached to
 // different nodes but in a same simulation, are connected using a socket pair.
 // TCP traffic is sent at a saturating data rate. Then the thoughput can
@@ -125,4 +125,6 @@
     Simulator::Stop(Seconds(40.0));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/helper/creator-utils.cc ns-3.38/src/fd-net-device/helper/creator-utils.cc
--- ns-3.37/src/fd-net-device/helper/creator-utils.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/helper/creator-utils.cc	2023-03-16 20:54:23.608868600 -0700
@@ -39,7 +39,7 @@
 {
 
 /// Flag to enable / disable verbose log mode
-int gVerbose = 0;
+bool gVerbose = false;
 
 /**
  * \brief Send the file descriptor back to the code that invoked the creation.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/helper/creator-utils.h ns-3.38/src/fd-net-device/helper/creator-utils.h
--- ns-3.37/src/fd-net-device/helper/creator-utils.h	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/helper/creator-utils.h	2023-03-16 20:54:23.608868600 -0700
@@ -31,7 +31,7 @@
 namespace ns3
 {
 
-extern int gVerbose;
+extern bool gVerbose;
 
 #define LOG(msg)                                                                                   \
     if (gVerbose)                                                                                  \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/helper/dpdk-net-device-helper.h ns-3.38/src/fd-net-device/helper/dpdk-net-device-helper.h
--- ns-3.37/src/fd-net-device/helper/dpdk-net-device-helper.h	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/helper/dpdk-net-device-helper.h	2023-03-16 20:54:23.608868600 -0700
@@ -37,9 +37,6 @@
   public:
     /**
      * Construct a DpdkNetDeviceHelper and initialize DPDK EAL
-     *
-     * \param argc Dpdk EAL args count.
-     * \param argv Dpdk EAL args list.
      */
     DpdkNetDeviceHelper();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/helper/emu-fd-net-device-helper.cc ns-3.38/src/fd-net-device/helper/emu-fd-net-device-helper.cc
--- ns-3.37/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2023-03-16 20:54:23.608868600 -0700
@@ -111,7 +111,7 @@
     // Figure out which interface index corresponds to the device name in the corresponding
     // attribute.
     //
-    struct ifreq ifr;
+    ifreq ifr;
     bzero(&ifr, sizeof(ifr));
     strncpy((char*)ifr.ifr_name, m_deviceName.c_str(), IFNAMSIZ - 1);
 
@@ -200,7 +200,7 @@
     }
 
     // Set the MTU of the device to the mtu of the associated network interface
-    struct ifreq ifr2;
+    ifreq ifr2;
 
     bzero(&ifr2, sizeof(ifr2));
     strcpy(ifr2.ifr_name, m_deviceName.c_str());
@@ -364,7 +364,7 @@
         // get the data that comes back from the socket creator process.  It will
         // be a magic number that we use as a consistency/sanity check.
         //
-        struct iovec iov;
+        iovec iov;
         uint32_t magic;
         iov.iov_base = &magic;
         iov.iov_len = sizeof(magic);
@@ -393,7 +393,7 @@
         // So, initialize the message header that describes the ancillary/control
         // data we expect to receive and point it to buffer.
         //
-        struct msghdr msg;
+        msghdr msg;
         msg.msg_name = nullptr;
         msg.msg_namelen = 0;
         msg.msg_iov = &iov;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/helper/netmap-net-device-helper.cc ns-3.38/src/fd-net-device/helper/netmap-net-device-helper.cc
--- ns-3.37/src/fd-net-device/helper/netmap-net-device-helper.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/helper/netmap-net-device-helper.cc	2023-03-16 20:54:23.608868600 -0700
@@ -258,7 +258,7 @@
     // we wait for the child (the socket creator) to complete and read the
     // socket it created using the ancillary data mechanism.
     //
-    // Tom Goff reports the possiblility of a deadlock when trying to acquire the
+    // Tom Goff reports the possibility of a deadlock when trying to acquire the
     // python GIL here.  He says that this might be due to trying to access Python
     // objects after fork() without calling PyOS_AfterFork() to properly reset
     // Python state (including the GIL).  There is no code to cause the problem
@@ -375,7 +375,7 @@
         // data we expect to receive and point it to buffer.
         //
         struct msghdr msg;
-        msg.msg_name = 0;
+        msg.msg_name = nullptr;
         msg.msg_namelen = 0;
         msg.msg_iov = &iov;
         msg.msg_iovlen = 1;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/helper/tap-fd-net-device-helper.cc ns-3.38/src/fd-net-device/helper/tap-fd-net-device-helper.cc
--- ns-3.37/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2023-03-16 20:54:23.608868600 -0700
@@ -224,7 +224,7 @@
         // which tells the system to make up a device name such as "tap123".
         //
         std::ostringstream ossDeviceName;
-        if (m_deviceName != "")
+        if (!m_deviceName.empty())
         {
             ossDeviceName << "-d" << m_deviceName;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/fd-net-device/model/fd-net-device.cc ns-3.38/src/fd-net-device/model/fd-net-device.cc
--- ns-3.37/src/fd-net-device/model/fd-net-device.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/fd-net-device/model/fd-net-device.cc	2023-03-16 20:54:23.608868600 -0700
@@ -207,7 +207,7 @@
 }
 
 void
-FdNetDevice::SetEncapsulationMode(enum EncapsulationMode mode)
+FdNetDevice::SetEncapsulationMode(EncapsulationMode mode)
 {
     NS_LOG_FUNCTION(this << mode);
     m_encapMode = mode;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/flow-monitor/examples/flowmon-parse-results.py ns-3.38/src/flow-monitor/examples/flowmon-parse-results.py
--- ns-3.37/src/flow-monitor/examples/flowmon-parse-results.py	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/flow-monitor/examples/flowmon-parse-results.py	2023-03-16 20:54:23.608868600 -0700
@@ -45,10 +45,6 @@
     ## class variables
     ## @var bins
     #  histogram bins
-    ## @var nbins
-    #  number of bins
-    ## @var number_of_flows
-    #  number of flows
     ## @var __slots_
     #  class variable list
     __slots_ = 'bins', 'nbins', 'number_of_flows'
@@ -76,8 +72,6 @@
     #  receive bit rate
     ## @var txBitrate
     #  transmit bit rate
-    ## @var fiveTuple
-    #  five tuple
     ## @var packetSizeMean
     #  packet size mean
     ## @var probe_stats_unsorted
@@ -140,14 +134,10 @@
 ## ProbeFlowStats
 class ProbeFlowStats(object):
     ## class variables
-    ## @var probeId
-    #  probe ID
     ## @var packets
     #  network packets
     ## @var bytes
     #  bytes
-    ## @var delayFromFirstProbe
-    #  delay from first probe
     ## @var __slots_
     #  class variable list
     __slots_ = ['probeId', 'packets', 'bytes', 'delayFromFirstProbe']
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/flow-monitor/examples/wifi-olsr-flowmon.py ns-3.38/src/flow-monitor/examples/wifi-olsr-flowmon.py
--- ns-3.37/src/flow-monitor/examples/wifi-olsr-flowmon.py	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/flow-monitor/examples/wifi-olsr-flowmon.py	2023-03-16 20:54:23.608868600 -0700
@@ -62,8 +62,7 @@
 
     port = 9   # Discard port(RFC 863)
     inetAddress = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.0.0.1"), port)
-    onOffHelper = ns.applications.OnOffHelper("ns3::UdpSocketFactory",
-                                  ns.network.Address(ns.addressFromInetSocketAddress(inetAddress)))
+    onOffHelper = ns.applications.OnOffHelper("ns3::UdpSocketFactory", inetAddress.ConvertTo())
     onOffHelper.SetAttribute("DataRate", ns.network.DataRateValue(ns.network.DataRate("100kbps")))
     onOffHelper.SetAttribute("OnTime", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=1]"))
     onOffHelper.SetAttribute("OffTime", ns.core.StringValue ("ns3::ConstantRandomVariable[Constant=0]"))
@@ -97,8 +96,7 @@
     for i, node in [(i, nodes.Get(i)) for i in range(nodes.GetN())]:
         destaddr = addresses[(len(addresses) - 1 - i) % len(addresses)]
         #print (i, destaddr)
-        genericAddress = ns.addressFromInetSocketAddress(ns.network.InetSocketAddress(destaddr, port))
-        onOffHelper.SetAttribute("Remote", ns.network.AddressValue(genericAddress))
+        onOffHelper.SetAttribute("Remote", ns.network.AddressValue(ns.network.InetSocketAddress(destaddr, port).ConvertTo()))
         container = ns.network.NodeContainer(node)
         app = onOffHelper.Install(container)
         urv = ns.CreateObject("UniformRandomVariable")#ns.cppyy.gbl.get_rng()
